import React, { useState, useEffect } from "react";
import socketIOClient from "socket.io-client";
let ENDPOINT = "http://0.0.0.0:8080";

function MotionDetectingClient(props) {
  const [response, setResponse] = useState("");

  useEffect(() => {
    if(props.server===undefined)
        {
          console.log("No end point passed so using default end point = "+ENDPOINT)
        }
        else
        {
          ENDPOINT=props.server
          console.log("Using End point that is passed = "+ENDPOINT)
        }
        
    const socket = socketIOClient(ENDPOINT);
    socket.emit("message","TEST_MESSAGE");
    
    socket.on("FromAPI", data => {
      
      setResponse(data);
    });

    var localMediaStream = null;
    let video = document.querySelector("#videoElement");
    let canvas = document.querySelector("#canvasElement");
    let ctx = canvas.getContext('2d');

    function sendSnapshot() {

      // This is component did mount
     video = document.querySelector("#videoElement");
    
    
      if (!localMediaStream) {
        return;
      }
  
     ctx.drawImage(video, 0, 0, video.videoWidth, video.videoHeight, 0, 0, 300, 150);
  
      let dataURL = canvas.toDataURL('image/jpeg');
      
      socket.emit('input image', dataURL);
  
      socket.emit('output   ')
  
      //var img = new Image();
      socket.on('out-image-event',function(data){
        
      if(props.debug!==undefined)
      {
      console.log("MotionDetectingClientLog: you are moving a lot!")
      console.log(data)
      }

      if(props.callback===undefined)
      {

      }
      else
      {
        props.callback(data)
      }
      
      //img.src = dataURL//data.image_data
  
      });
  
  
    }
    var constraints = {
      video: {
        width: { min: 640 },
        height: {  }
      }
    };
    navigator.mediaDevices.getUserMedia(constraints).then(function(stream) {
      video.srcObject = stream;
      localMediaStream = stream;
  
      setInterval(function () {
        sendSnapshot();
      }, 3000);
    }).catch(function(error) {
      console.log(error);
    });

  }, []);

  

  


  


  return (
        <div style={{width:'100%',height:'60%'}}>  
          <video autoplay="true" id="videoElement" style={{width:'100%',height:'60%'}}></video>
          <canvas id="canvasElement" style={{display:'none'}}></canvas>
        </div>
  );
}

export default MotionDetectingClient;
